/*
  colors.h

  For Tux Paint
  List of colors

  Copyright (c) 2002 by Bill Kendrick
  bill@newbreedsoftware.com
  http://www.newbreedsoftware.com/tuxpaint/

  June 14, 2002 - July 30, 2002
*/



/* What colors are available: */

enum {
  COLOR_BLACK,
  COLOR_WHITE,
  COLOR_RED,
  COLOR_PINK,
  COLOR_ORANGE,
  COLOR_YELLOW,
  COLOR_GREEN,
  COLOR_CYAN,
  COLOR_BLUE,
  COLOR_PURPLE,
  COLOR_BROWN,
  COLOR_GREY,
  NUM_COLORS
};


/* Hex codes: */

int color_hexes[NUM_COLORS][3] = {
  {0, 0, 0},
  {255, 255, 255},
  {255, 0, 0},
  {255, 128, 160},
  {255, 128, 0},
  {255, 255, 0},
  {0, 255, 0},
  {0, 255, 255},
  {0, 0, 255},
  {255, 0, 255},
  {128, 96, 0},
  {128, 128, 128}
};


/* Color names: */

char * color_names[NUM_COLORS] = {
  gettext_noop("Black"),
  gettext_noop("White"),
  gettext_noop("Red"),
  gettext_noop("Pink"),
  gettext_noop("Orange"),
  gettext_noop("Yellow"),
  gettext_noop("Green"),
  gettext_noop("Cyan"),
  gettext_noop("Blue"),
  gettext_noop("Purple"),
  gettext_noop("Brown"),
  gettext_noop("Grey")
};
